//
//  AnalogClockView.swift
//  Clock
//
//  Created by Holger Hinzberg on 18.01.16.
//  Copyright © 2016 Holger Hinzberg. All rights reserved.
//

import UIKit

class AnalogClockView: UIView
{
    override init(frame: CGRect)
    {
       super.init(frame: frame)
       self.backgroundColor = UIColor.whiteColor()
    }
   
    required init?(coder aDecoder: NSCoder)
    {
            super.init(coder: aDecoder)
    }
    
    
    // Only override drawRect: if you perform custom drawing.
    // An empty implementation adversely affects performance during animation.
    override func drawRect(rect: CGRect)
    {
        
        // Den grafischen Context holen
        let context = UIGraphicsGetCurrentContext()
        
        // Den Hintergrund zeichnen
        self.drawClockBackgroundWithContext(context!, size: self.bounds.size)
    }
    
    func drawClockBackgroundWithContext(
       context:CGContextRef, size:CGSize)
    {
        let height = size.height
        let width = size.width
        let minLength = fmin(height, width)
        
       // Die Linien- und die Füllfarbe setzen
       let fillColor:[CGFloat] = [0.9, 0.9, 0.9, 1.0]
       let strokeColor:[CGFloat] = [0.5, 0.5, 0.5, 1.0]
        CGContextSetStrokeColor(context, strokeColor)
        CGContextSetFillColor(context, fillColor)
       
        // Die Linienstärke setzen
        CGContextSetLineWidth(context, 2)
        
        // Den Kreis im View zentrieren
        let clockDiameter = minLength - 5
        let distanceLeft = (width - clockDiameter) / 2
        let distanceTop = (height - clockDiameter) / 2
        
        let borderRect = CGRectMake(distanceLeft, distanceTop, clockDiameter, clockDiameter)
        
        // Den Kreis zeichnen
        CGContextFillEllipseInRect(context, borderRect)
        CGContextStrokeEllipseInRect(context, borderRect)
    }
    
}
